import gtk
import pygtk
pygtk.require('2.0')
import os
import gobject
import sys
#Own wirtten clases
import errors
import settings

error = errors.Errors()
settings = settings.Settings()
class FirstRun():
	
	def __init__(self, main_app):
		self.main_app = main_app
		error.rollback_settings()
		self.interface()
		
	def interface(self):
		self.home_dir = os.environ.get("HOME")
		self.settings_dir = os.path.join(self.home_dir, ".myhella")
		
		#Creating window
		self.my_assistant = gtk.Assistant()
		self.my_assistant.set_size_request(600, 500)
		self.my_assistant.set_title("myHella Configuration Utility")
		self.my_assistant.set_border_width(10)
		self.my_assistant.connect('delete_event', self.cancel) #Closing the window
		self.my_assistant.connect('cancel', self.cancel) #Pressing the cancel button
		self.my_assistant.connect('close', self.quit) #Completing the walk-through
		
		#Creation of the starting assistant page
		self.one_label = gtk.Label("Welcome to the myHella first-run configuration utility.\nYou will now have to set up at least one server and point a download directory.\nTo continue press next...")
		self.one_label.set_line_wrap(True)
		self.one_label.show()
		
		self.my_assistant.append_page(self.one_label)
		self.my_assistant.set_page_type(self.one_label, gtk.ASSISTANT_PAGE_INTRO)
		self.my_assistant.set_page_title(self.one_label, "Set-Up myHella")
		self.my_assistant.set_page_complete(self.one_label, True)
		
		#Server configuration
		self.vbox_servers = gtk.VBox()
		self.vbox_servers.show()
		
		#Add server
		#Frame
		self.server_frame = gtk.Frame("Add Server")
		self.server_frame.show()
		self.vbox_servers.pack_start(self.server_frame, False, True, 10)
		
		self.vbox_add_server  = gtk.VBox()
		self.vbox_add_server.show()
		self.server_frame.add(self.vbox_add_server)
		
		#Serveraddress | Portnumber
		self.hbox_new_server = gtk.HBox()
		self.hbox_new_server.show()
		self.vbox_add_server.pack_start(self.hbox_new_server, False, True, 2)
		self.server_address_label = gtk.Label("Serveraddress:")
		self.server_address_label.show()
		self.hbox_new_server.pack_start(self.server_address_label, False, True)
		self.server_address_entry = gtk.Entry()
		self.server_address_entry.set_text('your.server.com')
		self.server_address_entry.show()
		self.hbox_new_server.pack_start(self.server_address_entry, False, True)
		#Portnumber
		self.server_port_label = gtk.Label("\tPort:")
		self.server_port_label.show()
		self.hbox_new_server.pack_start(self.server_port_label, False, True)
		self.server_port_entry = gtk.Entry()
		self.server_port_entry.set_width_chars(4)
		self.server_port_entry.set_max_length(4)
		self.server_port_entry.set_text('119')
		self.server_port_entry.show()
		self.hbox_new_server.pack_start(self.server_port_entry, False, True)
		
		#Username | SSL
		self.hbox_username_server = gtk.HBox()
		self.hbox_username_server.show()
		self.vbox_add_server.pack_start(self.hbox_username_server, False, True, 2)
		self.server_username_label = gtk.Label("Username:\t")
		self.server_username_label.show()
		self.hbox_username_server.pack_start(self.server_username_label, False, True)
		self.server_username_entry = gtk.Entry()
		self.server_username_entry.show()
		self.hbox_username_server.pack_start(self.server_username_entry, False, True)
		#SSL
		self.server_ssl_label = gtk.Label("\t")
		self.server_ssl_label.show()
		self.hbox_username_server.pack_start(self.server_ssl_label, False, True)
		self.server_ssl_checkbox = gtk.CheckButton("Enable SSL")
		self.server_ssl_checkbox.connect("toggled", self.enable_ssl)
		self.server_ssl_checkbox.show()
		self.hbox_username_server.pack_start(self.server_ssl_checkbox, False, True)
		
		#Password | Connections
		self.hbox_password_server = gtk.HBox()
		self.hbox_password_server.show()
		self.vbox_add_server.pack_start(self.hbox_password_server, False, True, 2)
		self.server_password_label = gtk.Label("Password:\t")
		self.server_password_label.show()
		self.hbox_password_server.pack_start(self.server_password_label, False, True)
		self.server_password_entry = gtk.Entry()
		self.server_password_entry.show()
		self.hbox_password_server.pack_start(self.server_password_entry, False, True)
		#Connections
		self.server_connections_label = gtk.Label("\tConnections:")
		self.server_connections_label.show()
		self.hbox_password_server.pack_start(self.server_connections_label, False, True)
		self.adj = gtk.Adjustment(1.0, 1.0, 99.0, 1.0, 5.0, 0.0)
		self.server_connections_spinbutton = gtk.SpinButton(self.adj, 0, 0)
		self.server_connections_spinbutton.set_wrap(True)
		self.server_connections_spinbutton.set_value(4)
		self.server_connections_spinbutton.set_numeric(True)	
		self.server_connections_spinbutton.show()
		self.hbox_password_server.pack_start(self.server_connections_spinbutton, False, True)
		
		#Save button
		self.hbox_save_server = gtk.HBox()
		self.hbox_save_server.show()
		self.vbox_add_server.pack_start(self.hbox_save_server, False, True, 2)
		self.server_save_button = gtk.Button(stock=gtk.STOCK_SAVE)
		self.server_save_button.show()
		self.server_save_button.connect("clicked", self.server_save)
		self.hbox_save_server.pack_start(self.server_save_button, False, True)
		
		#Serverlist
		self.servers  = gtk.ScrolledWindow()
		self.servers.set_policy(gtk.POLICY_AUTOMATIC, gtk.POLICY_AUTOMATIC)
		self.servers.show()
		self.vbox_servers.pack_start(self.servers)
		
		#[server, username, password, connections, port, ssl, enabled]
		self.servers_list = gtk.ListStore(str, str, str, int, str, gobject.TYPE_BOOLEAN, gobject.TYPE_BOOLEAN)
		self.servers_tree = gtk.TreeView(self.servers_list)
		self.servers_tree.connect("key_press_event", self.server_delete)
		self.servers_tree.show()
		
		#Adding the treeView to the server scrolled window
		self.servers.add_with_viewport(self.servers_tree)
		
		#Creating column ServerAddress
		self.server_address_column = gtk.TreeViewColumn("Serveraddress")
		self.servers_tree.append_column(self.server_address_column)
		self.cell = gtk.CellRendererText()
		self.server_address_column.pack_start(self.cell, True)
		self.server_address_column.set_resizable(True)
		self.server_address_column.add_attribute(self.cell, 'text', 0) #0 indicates where this item is positioned in the ListStore
		
		#Creating column Username
		self.user_column = gtk.TreeViewColumn("Username")
		self.servers_tree.append_column(self.user_column)
		self.cell = gtk.CellRendererText()
		self.user_column.pack_start(self.cell, True)
		self.user_column.set_resizable(True)
		self.user_column.add_attribute(self.cell, 'text', 1) #0 indicates where this item is positioned in the ListStore
		
		#Creating column Connections
		self.conn_column = gtk.TreeViewColumn("Connections")
		self.servers_tree.append_column(self.conn_column)
		self.cell = gtk.CellRendererText()
		self.conn_column.pack_start(self.cell, True)
		self.conn_column.set_resizable(True)
		self.conn_column.add_attribute(self.cell, 'text', 3) #0 indicates where this item is positioned in the ListStore
		
		#Creating column Port
		self.port_column = gtk.TreeViewColumn("Port")
		self.servers_tree.append_column(self.port_column)
		self.cell = gtk.CellRendererText()
		self.port_column.pack_start(self.cell, True)
		self.port_column.set_resizable(True)
		self.port_column.add_attribute(self.cell, 'text', 4) #0 indicates where this item is positioned in the ListStore
		
		#Creating column SSL
		self.ssl_column = gtk.TreeViewColumn("SSL")
		self.servers_tree.append_column(self.ssl_column)
		self.cell = gtk.CellRendererToggle()
		self.ssl_column.pack_start(self.cell, False)
		self.ssl_column.set_resizable(True)
		self.ssl_column.add_attribute(self.cell, 'active', 5) #0 indicates where this item is positioned in the ListStore
		self.cell.connect("toggled", self.enable_ssl_overview)
		
		#Creating column enabled
		self.enabled_column = gtk.TreeViewColumn("Enabled")
		self.servers_tree.append_column(self.enabled_column)
		self.cell = gtk.CellRendererToggle()
		self.enabled_column.pack_start(self.cell, False)
		self.enabled_column.set_resizable(True)
		self.enabled_column.add_attribute(self.cell, 'active', 6) #0 indicates where this item is positioned in the ListStore
		self.cell.connect("toggled", self.enable_server_overview)
		
		self.my_assistant.append_page(self.vbox_servers)
		self.my_assistant.set_page_type(self.vbox_servers, gtk.ASSISTANT_PAGE_CONTENT)
		self.my_assistant.set_page_title(self.vbox_servers, "Set-Up myHella - Servers")
		self.my_assistant.set_page_complete(self.vbox_servers, True)
		
		#Directory and notifications
		self.vbox_download_directory = gtk.VBox()
		self.vbox_download_directory.show()
		self.hbox_download_directory = gtk.HBox()
		self.hbox_download_directory.show()
		self.vbox_download_directory.pack_start(self.hbox_download_directory, False, True, 2)
		self.download_directory_label = gtk.Label("Directory:")
		self.download_directory_label.show()
		self.hbox_download_directory.pack_start(self.download_directory_label, False, True, 2)
		self.download_directory_entry = gtk.Entry()
		self.download_directory_entry.set_text(self.home_dir)
		self.download_directory_entry.show()
		self.hbox_download_directory.pack_start(self.download_directory_entry, False, True, 2)
		self.download_directory_button = gtk.Button("...")
		self.download_directory_button.show()
		self.download_directory_button.connect("clicked", self.download_directory_choose)
		self.hbox_download_directory.pack_start(self.download_directory_button, False, True, 2)
		#Notifications
		self.notifications_checkbox = gtk.CheckButton("Enable hellaNZB notifications")
		self.notifications_checkbox.show()
		self.vbox_download_directory.pack_start(self.notifications_checkbox, False, True)
		
		self.my_assistant.append_page(self.vbox_download_directory)
		self.my_assistant.set_page_type(self.vbox_download_directory, gtk.ASSISTANT_PAGE_CONTENT)
		self.my_assistant.set_page_title(self.vbox_download_directory, "Set-Up myHella - Other settings")
		self.my_assistant.set_page_complete(self.vbox_download_directory, True)
		
		self.last_label = gtk.Label("Cnfiguring myHella is done now and the settings will be stored on your hard drive.")
		self.last_label.set_line_wrap(True)
		self.last_label.show()
		
		self.my_assistant.append_page(self.last_label)
		self.my_assistant.set_page_type(self.last_label, gtk.ASSISTANT_PAGE_CONFIRM)
		self.my_assistant.set_page_title(self.last_label, "Set-Up myHella")
		self.my_assistant.set_page_complete(self.last_label, True)
		
		self.my_assistant.show()
		gtk.main()
		
	#Events
	def enable_ssl(self, widget, data=None):
		if widget.get_active():
			self.server_port_entry.set_text('563')
		else:
			self.server_port_entry.set_text('119')
			
	def enable_ssl_overview(self, widget, data=None):
		selected_item = self.servers_tree.get_selection()
		tree_model, tree_iter = selected_item.get_selected()
		
		selection = 0
		for x in range(len(data)):
			selection = data
		
		try:
			if self.servers_list[selection][5] == True:
				self.servers_list[selection][5] = False
			else:
				self.servers_list[selection][5] = True
		except:
			print "No server selected"
			
	def enable_server_overview(self, widget, data=None):
		selected_item = self.servers_tree.get_selection()
		tree_model, tree_iter = selected_item.get_selected()
		
		selection = 0
		for x in range(len(data)):
			selection = data
		
		try:
			if self.servers_list[selection][6] == True:
				self.servers_list[selection][6] = False
			else:
				self.servers_list[selection][6] = True
		except:
			print "No server selected"
			
	def server_delete(self, widget, data=None):
		#Only when pressing the delete button on the keyboard
		#a sever can be deleted!
		key = gtk.gdk.keyval_name(data.keyval)
 		if key == "Delete":
			selected_item = self.servers_tree.get_selection()
			tree_model, tree_iter = selected_item.get_selected()
			self.servers_list.remove(tree_iter)
			
	def server_save(self, widget, data=None):
		#Check the values the user entered, if anything is wrong permission should be set to False
		permission = True
		message = ""
		if self.server_address_entry.get_text() == "":
			permission = False
			message = "- the server address is missing"
		if self.server_port_entry.get_text() == "":
			permission = False
			message = message + "\n- the port number is missing"
			
		if permission == True:
			self.servers_list.append([self.server_address_entry.get_text(), self.server_username_entry.get_text(), self.server_password_entry.get_text(), self.server_connections_spinbutton.get_value(), self.server_port_entry.get_text(), self.server_ssl_checkbox.get_active(), True])
			#Resetting all fielsd to the standard value
			self.server_address_entry.set_text('your.server.com')
			self.server_password_entry.set_text('')
			self.server_username_entry.set_text('')
			self.server_port_entry.set_text('119')
			self.server_ssl_checkbox.set_active(False)
			self.server_connections_spinbutton.set_value(4)
		else:
			message = "Please correct the following errors:\n" + message
			error.normal_error(message)
			
	def download_directory_choose(self, widget, data=None):
		self.download_directory_folder_selection = gtk.FileChooserDialog("Select a download directory",
 													None,
 													gtk.FILE_CHOOSER_ACTION_SELECT_FOLDER,
 													(gtk.STOCK_CANCEL, gtk.RESPONSE_CANCEL,
 													gtk.STOCK_OPEN, gtk.RESPONSE_OK))
		self.download_directory_folder_selection.set_default_response(gtk.RESPONSE_OK)
		self.download_directory_folder_selection.set_select_multiple(False)
 		self.download_directory_folder_selection.set_filename(self.download_directory_entry.get_text())
		response = self.download_directory_folder_selection.run()
	
		if response == gtk.RESPONSE_OK:
			folder = self.download_directory_folder_selection.get_filename()
			self.download_directory_entry.set_text(folder)
			
		self.download_directory_folder_selection.destroy()
		
	def cancel(self, widget=None, data=None):
		self.my_assistant.hide()
		error.rollback_settings()
		gtk.main_quit()
	
	def quit(self, widget=None, data=None):
		#Check wheather all settings could be saved, if so shutdown
		if self.save_settings() == True:
			self.my_assistant.hide()
			#myHella.py var which indicates the main program that
			#the configuration is ok and the program may run
			self.main_app.config_needed = False
			gtk.main_quit()
		
	def save_settings(self, widget=None, data=None):
		#Create .myhella folder in the homedirectory
		os.system("mkdir " + os.path.join(self.home_dir,".myhella"))
			
		#Check the values the user entered, if anything is wrong permission should be set to False
		permission = True
		message = ""
		if len(self.servers_list) == 0:
			permission = False
			message = "- No servers were configured"
			
		test1 = self.download_directory_entry.get_text()
		test1 = test1 + "/"
		if test1[len(test1)-2:-1] == "/":
			test1 = test1[:-1]
			print "goede dir: " + test1
			self.download_directory_entry.set_text(test1)
		else:
			print "goede directory: " + test1
			self.download_directory_entry.set_text(test1)
			
		if not os.path.isdir(self.download_directory_entry.get_text()):
			permission = False
			message = message + "\n- The chosen dwonload directory isn't a directory"
			
		#Create configs if all values the user entered are correct
		if permission == True:
			#hellanzb.conf
			self.create_hellanzb_config()
			#gconf '/apps/myhella/'
			self.create_myhella_config()
			return True
		else:
			message = "Please correct the following errors:\n" + message
			error.normal_error(message)
			return False
		
	def create_hellanzb_config(self):
		try:
			self.servers_save_list = ""
				
			#Check which servers may be added to the hellanzb.conf file
			for x in range(len(self.servers_list)):
				#Every server that is enabled will be added to the hellanzb.conf file
				if self.servers_list[x][6] == True:
					#When no username is filled in the username and password will be set to 'None'
					if  self.servers_list[x][1] == "":
						self.username_txt = "username = None"
						self.password_txt = "password = None"
					else:
						self.username_txt = "username = '" + self.servers_list[x][1] + "'"
						self.password_txt = "password = '" + self.servers_list[x][2] + "'"
					#Adding the hellanzb.conf-string to temporary var
					self.servers_save_list = self.servers_save_list + "defineServer(id='" + self.servers_list[x][0] + "',\n\thosts = [ '" + self.servers_list[x][0] + ":" +  self.servers_list[x][4] + "' ],\n\t" +  self.username_txt + ",\n\t" + self.password_txt + ",\n\tconnections = " + str(self.servers_list[x][3]) + ",\n\tantiIdle = 4.5 * 60,\n\tssl = " + str(self.servers_list[x][5]) + "\n\t)\n" 
				
			#Check which download directory is specified and create hellanzb.conf-string
			self.directory_txt = "Hellanzb.PREFIX_DIR = '" + self.download_directory_entry.get_text() + "'"
			self.directory = self.download_directory_entry.get_text()
				
			#Opening the hellanzb.conf file deliverd by myHella
			file = open(os.path.join(os.path.abspath(os.path.dirname(__file__)),"hellanzb.conf"), "r")
			hellanzb_conf = file.read()
			file.close
				
			#Changing the configuration values
			hellanzb_conf = hellanzb_conf.replace("SETSERVERS",self.servers_save_list)
			hellanzb_conf = hellanzb_conf.replace("SETDOWNLOADFOLDER",self.directory_txt)
			hellanzb_conf = hellanzb_conf.replace("Hellanzb.LIBNOTIFY_NOTIFY = False","Hellanzb.LIBNOTIFY_NOTIFY = " + str(self.notifications_checkbox.get_active()))
			hellanzb_conf = hellanzb_conf.replace("Hellanzb.LIBNOTIFY_NOTIFY = True","Hellanzb.LIBNOTIFY_NOTIFY = " + str(self.notifications_checkbox.get_active()))
				
			#Writing the hellanzb.conf file to ~/.myhella/hellanzb.conf
			file = open(os.path.join(self.settings_dir,"hellanzb.conf"), "w")
			file.write(hellanzb_conf)
			file.close
		except:
			error.rollback_settings()
			error.critical_error("Something went wrong while storing the hellaNZB settings!\n\nDetails:\n" + str(sys.exc_info()[1]))
		
	def create_myhella_config(self):
		try:
			#Creating the nessecary keys in gconf
			settings.set_key(key="hellanzb/downloadfolder", type="string", value=self.directory)
			settings.set_key(key="hellanzb/libnotify", type="bool", value=self.notifications_checkbox.get_active())
			
			tmp = []
			for x in range(len(self.servers_list)):			
				tmp.append(str(self.servers_list[x][0]))
				tmp.append(str(self.servers_list[x][1]))
				tmp.append(str(self.servers_list[x][2]))
				tmp.append(str(self.servers_list[x][3]))
				tmp.append(str(self.servers_list[x][4]))
				tmp.append(str(self.servers_list[x][5]))
				tmp.append(str(self.servers_list[x][6]))
				
			settings.set_key(key="hellanzb/servers", type="list", value=tmp, list_value="string", output=False)

		except:
			error.rollback_settings()
			error.critical_error("Something went wrong while storing the settings in the Gnome Configuration Editor!\n\nDetails:\n" + str(sys.exc_info()[1]))
