import os
import sys
from xmlrpclib import ServerProxy

import errors

error = errors.Errors()
class Hellanzb:
	def __init__(self):
		self.proxy = None
		self.started = False
		self.started_success = False
		self.updating_queue = False
		
	def connect(self, hella, hellaconfig):
		try:
			os.system(hella + " -c " + hellaconfig + " -D")
			self.started = True
			self.proxyConnect()
			self.started_success = True
		except:
			if self.started == False:
				message = "Could not start the hellaNZB daemon"
			elif self.started_success	== False:
				message = "Could not connect to hellaNZB daemon"
			error.print_error(message)
			error.normal_error(message)
		
	def proxyConnect(self):
		self.proxy = ServerProxy('http://hellanzb:changeme@localhost:8760/')
		
	def disconnect(self, hellaexec):
		try:
			if self.started == True:
				os.system(hellaexec + " shutdown")
			#self.proxy.shutdown()
			self.started = False
			self.started_success = False
			self.proxyDisconnect()
		except:
			print "Hellannzb shutdown progress failed. No big deal, hellanzb will be shutdown!"
			
	def proxyDisconnect(self):
		self.proxy = None
		
	def enqueue(self, location, rm=False):
		try:
			location = os.path.realpath(location)
			self.proxy.enqueue(location)
			if rm == True:
				os.system("rm '" + location + "'")
		except:
			error.print_error("Could not add NZB to queue: " + str(sys.exc_info()[1]))
			
	def dequeue(self, id):
		try:
			self.proxy.dequeue(id)
		except:
			error.print_error("Could not remove NZB  with id " + id + " from the queue: " + str(sys.exc_info()[1]))
			
	def setMaxrate(self, maxrate):
		try:
			self.proxy.maxrate(maxrate)
		except:
			error.print_error("Could not change the maxrate: " + str(sys.exc_info()[1]))
			
	def cancel(self):
		try:
			self.proxy.cancel()
		except:
			error.print_error("Could not cancel the download: " + str(sys.exc_info()[1]))
			
	def clear(self):
		try:
			self.proxy.clear()
		except:
			error.print_error("Could not clear the queue: " + str(sys.exc_info()[1]))
			
	def force(self, id):
		try:
			self.proxy.force(id)
		except:
			error.print_error("Could not force this download to start:" + str(sys.exc_info()[1]))
			
	def moveNzbUp(self, id, shift=0):
		try:
			if shift == 0:
				self.proxy.up(id)
			else:
				self.proxy.up(id, shift)
		except:	
			error.print_error("Could not move nzb up: " + str(sys.exc_info()[1]))
			
	def moveNzbDown(self, id, shift=0):
		try:
			if shift == 0:
				self.proxy.down(id)
			else:
				self.proxy.down(id, shift)
		except:	
			error.print_error("Could not move nzb down: " + str(sys.exc_info()[1]))
			
	def pause(self):
		try:
			self.proxy.pause()
		except:
			error.print_error("Could not pause the download using the proxy server!")
			
	def unpause(self, hellaexec):
		try:
			os.system(hellaexec + " continue")
		except:
			error.print_error("Could not continue the download using the proxy server!")

