#!/usr/bin/env python

#abspath OR realpath  -> make gets the real path of a symlink

#1013
#Forcing an nzb to download by double clicking
#new layout: at bottom a statusbar (always visible), better ordered
#			 info at stats tab, thanks to Rz new icons added!
#Pause button (toggle button) inside main window

version = "2.0 build 1013"
#Own wirtten clases
import firstRun
import errors
import messages
import settings
import hellanzb
error = errors.Errors()
message = messages.Messages()
settings = settings.Settings(version)
hellanzb = hellanzb.Hellanzb()


#Direct imports
try:
	import gtk
	import gtk.glade
	import pygtk
	pygtk.require('2.0')
	import threading
	import gobject
	import os
	import sys
	import gnome
	import gnome.ui
	import bonobo
	#From imports
	from time import sleep
	from pyinotify import WatchManager, Notifier, ProcessEvent, EventsCodes
	from string import lower
except:
	error.critical_error("Some of the requirements has not been satisfied. Make sure the following packages are installed and restart myHella:\n- gtk\n- pygtk\n- pyinotify")

gobject.threads_init()

class MyHella(threading.Thread):
	def __init__(self):
		super(MyHella, self).__init__()		
		if not os.path.isfile("/usr/bin/hellanzb.py") and not os.path.isfile("/usr/bin/hellanzb"):
			error.critical_error("In order to run myHella you need to have hellaNZB installed.\nThis application will now close. You should only restart it whenever hellaNZB is installed on your system.\nFor more information on hellaNZB checkout their website: http://www.hellanzb.com/trac/")
		elif os.path.isfile("/usr/bin/hellanzb.py"):
			self.hella = "/usr/bin/hellanzb.py"
		elif os.path.isfile("/usr/bin/hellanzb"):
			self.hella = "/usr/bin/hellanzb"
			
		self.declareVars()
		self.checkConfig()
		self.createTray()
		self.interface()
		
	def run(self):
		loopCount = 0
		
		while self.running:
			#getting status information
			if hellanzb.started_success == True:
				try:
					self.hellanzb_status = hellanzb.proxy.status()
				except:
					error.normal_error("Could connect to hellaNZB. Please try to reconnect manual!")
					self.connectHellanzbStop()
					
				try:
					self.updateStats()
					hellanzb.updating_queue = True
					self.updateQueue()
					hellanzb.updating_queue = False
				except:
					error.print_error("Could not update stats and/or queue: " + str(sys.exc_info()[1]))	
					
				#Check if watch_dir has been changed in gconf
				self.checkWatchDirChange()
				#Watching the watch_dir!
				if self.monitoring == True:
					try:
						self.notifier.process_events()
						if self.notifier.check_events(0):
							self.notifier.read_events()
					except KeyboardInterrupt:
						self.notifier.stop()
						return
			#sleep
			sleep(self.update_speed)
		
	def declareVars(self):
		#self.running indicates wheather myHella is running, if so the thread
		#will update the status, if not the thread will be closed!
		self.running = True
		#self.running_hellanzb indicates wheather hellanzb is running or not
		#standard hellanzb isn't running when starting myHella
		self.running_hellanzb = False
		#If hellanzb isn't running no nzb's should be added as there is no
		#server to handle it
		self.add_nzb_permission = False
		self.window_hidden = False
		self.monitoring = False
		self.pause_hellanzb = False
		
		self.settings_dir = os.path.join(os.environ.get("HOME"), ".myhella")
		self.hella_config_file = os.path.join(self.settings_dir, "hellanzb.conf")
		self.install_dir = os.path.realpath(os.path.abspath(os.path.dirname(__file__)))
		#[server, username, password, connections, port, ssl, enabled]
		self.servers_list = gtk.ListStore(str, str, str, int, str, gobject.TYPE_BOOLEAN, gobject.TYPE_BOOLEAN)
		self.servers = []
		self.server_string_old = ""
		self.downoad_dir_old = ""
		self.watch_path = ""
		
		self.config_needed = True
		
		self.queue_lst = gtk.ListStore(str, str, int) #name, size, id
		self.queue = None
		
	def checkConfig(self):
		if os.path.isfile(self.hella_config_file) == False:
			print "config needed"
			firstRun.FirstRun(self)
			if self.config_needed == True:
				error.critical_error("You haven't finished the configuration of myHella.\nMyHella will now shut down!")
		else:
			self.config_needed = False
			
		if settings.get_key(key="general/updatespeed", type="int", default=-1) < 0:
			settings.set_key(key="general/updatespeed", type="int", value=1)
		self.update_speed = settings.get_key(key="general/updatespeed", type="int", default=1)
		
		if settings.get_key(key="general/watchdir", type="string", default="none") == "none":
			settings.set_key(key="general/watchdir", type="string", value=os.environ.get("HOME"))
			
		if settings.get_key(key="general/removeNzb", type="bool", default="none") == "none":
			settings.set_key(key="general/removeNzb", type="bool", value=False)
		
		if settings.get_key(key="general/watchdir_recursive", type="bool", default=-1) < 0:
			settings.set_key(key="general/watchdir_recursive", type="bool", value=False)
			
		self.watch_path = os.path.realpath(settings.get_key(key="general/watchdir", type="string"))
		
		self.recursive = settings.get_key(key="general/watchdir_recursive", type="bool")
			
		self.readServerList()
			
	def interface(self):
		#Loading Glade file
		self.my_hella_glade = gtk.glade.XML(os.path.realpath(os.path.join(self.install_dir,"glade/myHella.glade")))
		#Window
		self.window = self.my_hella_glade.get_widget("window")
		self.window.connect("delete_event", self.close)
		#About window
		self.window_about = self.my_hella_glade.get_widget("about")
		self.window_about.set_property("version", version)
		self.window_about.connect("close", self.aboutClose)
		self.window_about.connect("delete_event", self.aboutClose)
		self.window_about.connect("response", self.aboutResponse)
		
		#Adding dnd to the entire window
		self.window.drag_dest_set(gtk.DEST_DEFAULT_ALL,
										[('text/plain', 0, 0)], gtk.gdk.ACTION_COPY)
		self.window.connect("drag_data_received", self.dndNzb)
		
		self.window.show()
		#Toolbar options
		self.options_connect = self.my_hella_glade.get_widget("options_connect")
		self.options_connect.connect("clicked",self.connectHellanzb)
		self.options_disconnect = self.my_hella_glade.get_widget("options_disconnect")
		self.options_disconnect.connect("clicked",self.connectHellanzb)
		self.options_pause = self.my_hella_glade.get_widget("options_pause")
		self.options_pause.connect("clicked",self.pauseHellanzb)
		self.options_open = self.my_hella_glade.get_widget("options_open")
		self.options_open.connect("clicked", self.importNzb)
		self.options_cancel = self.my_hella_glade.get_widget("options_cancel")
		self.options_cancel.connect("clicked",self.cancelCurrent)
		self.options_clear_queue = self.my_hella_glade.get_widget("options_clear_queue")
		self.options_clear_queue.connect("clicked",self.clearQueue)
		self.options_nzb_up = self.my_hella_glade.get_widget("options_nzb_up")
		self.options_nzb_down = self.my_hella_glade.get_widget("options_nzb_down")
		self.options_seperator = self.my_hella_glade.get_widget("options_seperator")
		self.options_about = self.my_hella_glade.get_widget("options_about")
		self.options_about.connect("clicked", self.about)
		self.options_quit = self.my_hella_glade.get_widget("options_quit")
		self.options_quit.connect("clicked", self.close)
		#TABS :-)
		#Stats
		self.stats_current_label = self.my_hella_glade.get_widget("stats_downloading_current_label")
		self.stats_speed_label = self.my_hella_glade.get_widget("stats_downloading_speed_label")
		self.stats_progress_bar = self.my_hella_glade.get_widget("stats_progress_bar")
		self.stats_processing_label = self.my_hella_glade.get_widget("stats_processing_what_label")
		self.stats_downloading_eta_label = self.my_hella_glade.get_widget("stats_downloading_eta_label")
		
		self.stats_total_download = self.my_hella_glade.get_widget("stats_total_download_label")
		self.stats_total_files = self.my_hella_glade.get_widget("stats_total_files_label")
		self.stats_total_uptime = self.my_hella_glade.get_widget("stats_total_uptime_label")
		
		self.stats_queued_count = self.my_hella_glade.get_widget("stats_queued_count")
		self.stats_queued_more = self.my_hella_glade.get_widget("stats_queued_more")
		self.stats_queued_size = self.my_hella_glade.get_widget("stats_queued_size")
		#Queue Tab
		self.queue = self.my_hella_glade.get_widget("queue")
		
		self.queue_tree = gtk.TreeView(self.queue_lst)
		self.queue_tree.connect("key_press_event", self.dequeueNzb)
		self.queue_tree.connect("button-press-event", self.forceNzb)
		
		self.queue.add_with_viewport(self.queue_tree)
		self.queue_tree.show()
		
		self.columnName = gtk.TreeViewColumn("Name")
		self.queue_tree.append_column(self.columnName)
		self.cell = gtk.CellRendererText()
		self.columnName.pack_start(self.cell, True)
		self.columnName.add_attribute(self.cell, 'text', 0)
		
		self.columnSize = gtk.TreeViewColumn("Size")
		self.queue_tree.append_column(self.columnSize)
		self.cell = gtk.CellRendererText()
		self.columnSize.pack_start(self.cell, True)
		self.columnSize.add_attribute(self.cell, 'text', 1)
		#General settings
		self.general_settings_watchdir_entry = self.my_hella_glade.get_widget("combo-entry1")
		self.general_settings_watchdir_entry.set_text(settings.get_key(key="general/watchdir", type="string"))
		self.general_settings_watchfolder_recursive_checkbox = self.my_hella_glade.get_widget("settings_general_watchfolder_recursive_checkbox")
		self.general_settings_watchfolder_recursive_checkbox.set_active(self.recursive)
		self.general_settings_updatespeed_scale = self.my_hella_glade.get_widget("settings_general_updatespeed_scale")
		self.general_settings_updatespeed_scale.set_value(self.update_speed)
		self.general_settings_removeNzb_checkbox = self.my_hella_glade.get_widget("settings_general_removeNzb_checkbox")
		self.general_settings_removeNzb_checkbox.set_active(settings.get_key(key="general/removeNzb", type="bool"))
		
		self.general_settings_apply_button = self.my_hella_glade.get_widget("settings_general_apply_button")
		self.general_settings_apply_button.connect("clicked", self.saveGeneralSettings)
		self.general_settings_cancel_button = self.my_hella_glade.get_widget("settings_general_cancel_button")
		self.general_settings_cancel_button.connect("clicked", self.restoreGeneralSettings)
		#Statusbar
		self.stats_status_hellanzb_image = self.my_hella_glade.get_widget("stats_status_hellanzb")
		
	def createTray(self):
		#Tray icon
		self.tray_icon = gtk.StatusIcon()
		self.tray_icon.set_from_stock(gtk.STOCK_CONNECT)
		#icon_16.png
		self.tray_icon.set_from_file(os.path.join(os.path.abspath(os.path.dirname(__file__)), "glade/myhella_128.png"))
		self.tray_icon.set_tooltip("myHella")
		
		#Right click menu
		self.tray_icon_menu = gtk.Menu()
		self.tray_icon_menu.show()
		#Right click menu-options
		self.tray_icon_connect = gtk.ImageMenuItem(gtk.STOCK_CONNECT)
		self.tray_icon_connect.connect("activate", self.connectHellanzb)
		self.tray_icon_connect.show()
		self.tray_icon_menu.append(self.tray_icon_connect)
		
		self.tray_icon_disconnect = gtk.ImageMenuItem(gtk.STOCK_DISCONNECT)
		self.tray_icon_disconnect.connect("activate", self.connectHellanzb)
		self.tray_icon_disconnect.hide()
		self.tray_icon_menu.append(self.tray_icon_disconnect)
		
		self.tray_icon_pause = gtk.MenuItem("_Pause", True)
		self.tray_icon_pause.connect("activate", self.pauseHellanzb)
		self.tray_icon_pause.hide()
		self.tray_icon_menu.append(self.tray_icon_pause)
		
		self.tray_icon_continue = gtk.MenuItem("_Continue", True)
		self.tray_icon_continue.connect("activate", self.pauseHellanzb)
		self.tray_icon_continue.hide()
		self.tray_icon_menu.append(self.tray_icon_continue)
		
		self.tray_icon_open_nzb = gtk.ImageMenuItem(gtk.STOCK_OPEN)
		self.tray_icon_open_nzb.connect("activate", self.importNzb)
		self.tray_icon_open_nzb.hide()
		self.tray_icon_menu.append(self.tray_icon_open_nzb)
		
		self.tray_icon_clear_queue = gtk.ImageMenuItem(gtk.STOCK_CLEAR)
		self.tray_icon_clear_queue.connect("activate", self.clearQueue)
		self.tray_icon_clear_queue.hide()
		self.tray_icon_menu.append(self.tray_icon_clear_queue)
		
		self.tray_icon_exit = gtk.ImageMenuItem(gtk.STOCK_QUIT)
		self.tray_icon_exit.connect("activate", self.close)
		self.tray_icon_exit.show()
		self.tray_icon_menu.append(self.tray_icon_exit)
		
		#myHella will appear and dissapear when clicking the tray
		self.tray_icon.connect('activate', self.minimizeToTray, self.tray_icon_menu)
		#The tray icon menu-options must appear on a right-click on the tray icon
		self.tray_icon.connect('popup-menu', self.showTrayIconMenu)
		
	def showTrayIconMenu(self, status_icon=None, button=None, activate_time=None):
		self.tray_icon_menu.popup(None, None, gtk.status_icon_position_menu, button, activate_time, status_icon)
		
	def minimizeToTray(self, widget=None, data=None):
		if self.window_hidden == True:
			self.window.show()
			self.window_hidden = False
		else:
			self.window.hide()
			self.window_hidden = True
			
	#STATS
	def statsResetDefault(self):
		self.stats_speed_label.set_text("0")
		self.stats_processing_label.set_text("processing nothing")
		self.stats_downloading_eta_label.set_text("0:00:00")
		
	def updateStats(self):
		if self.hellanzb_status['is_paused'] == True:
			self.stats_speed_label.set_text("0")
			self.stats_downloading_eta_label.set_text("0:00:00")
		else:
			#Downloading rate
			self.stats_speed_label.set_text(str(self.hellanzb_status['rate']))
				
			if len(self.hellanzb_status['currently_downloading']) > 0:
				#Progress bar percent_complete
				fraction = (0.00 + int(self.hellanzb_status['percent_complete'])) / 100
				self.stats_progress_bar.set_fraction(fraction)
				#Text on Progress bar
				progress_text = str(self.hellanzb_status['percent_complete']) + "% "
				progress_text = progress_text + "(" + self.calculateMbToGb(self.hellanzb_status['currently_downloading'][0]['total_mb']*fraction)
				progress_text = progress_text + " of " + self.calculateMbToGb(self.hellanzb_status['currently_downloading'][0]['total_mb']) + ")"
				#Currently downloading
				downloading_text = str(self.hellanzb_status['currently_downloading'][0]['nzbName'])
			else:
				fraction = 0
				progress_text = "0%"
				downloading_text = "downloading nothing"
			self.stats_progress_bar.set_fraction(fraction)
			self.stats_progress_bar.set_text(progress_text)
			self.stats_current_label.set_text(downloading_text)
			
			self.stats_downloading_eta_label.set_text(self.calculateEta(self.hellanzb_status['eta']))
			
		processing = None
		if len(self.hellanzb_status['currently_processing']) > 0:
			for x in range(len(self.hellanzb_status['currently_processing'])):
				if x == 0:
					processing = self.hellanzb_status['currently_processing'][x]['nzbName']
				else:
					processing = processing + ", " + self.hellanzb_status['currently_processing'][x]['nzbName']
		else:
			processing = "processing nothing"	
		self.stats_processing_label.set_text(processing)
			
		#Totals
		#Total MB/GB downloaded
		self.stats_total_download.set_text(self.calculateMbToGb(self.hellanzb_status['total_dl_mb']))
		self.stats_total_files.set_text(str(self.hellanzb_status['total_dl_files']))
		self.stats_total_uptime.set_text(self.hellanzb_status['uptime'])
			
	#Queue methods
	def updateQueue(self):
		if not self.queue == self.hellanzb_status['queued']:
			#To set the size of the total queue, if this is True the exact size isn't known
			#Cause: hellanzb isn't always giving the size of the download right as you add it to the queue
			almost = False
			queue_total_mb = 0
			
			self.queue = self.hellanzb_status['queued']
			self.queue_lst.clear()
			
			for x in range(len(self.queue)):
				try:
					size = self.calculateMbToGb(self.queue[x]['total_mb'])
					queue_total_mb = queue_total_mb + self.queue[x]['total_mb']
				except KeyError:
					size = "n.a."
					almost = True
				self.queue_lst.append([self.queue[x]['nzbName'], size, self.queue[x]['id']])
				
			#Setting the total queue size
			self.stats_queued_count.set_text(str(len(self.queue)))
			queue_total_mb_str = "0MB"
			queue_total_mb_str = self.calculateMbToGb(queue_total_mb)
			self.stats_queued_size.set_text(queue_total_mb_str)
			if almost == True:
				self.stats_queued_more = "more than "
			else:
				self.stats_queued_more = ""
			queue_size = gtk.Label("Queue (" + queue_total_mb_str + ")")
			
	def cancelCurrent(self, widget=None, data=None):
		if hellanzb.started_success == True:
			if message.question("Cancel current download", "Are you sure you want to cancel the current download?") == True:
				hellanzb.cancel()
		else:
			message.message("Not connected", "You must be connected to be able to remove an NZB from the queue!")
			
	def clearQueue(self, widget=None, data=None):
		if hellanzb.started_success == True:
			if message.question("Clear queue", "Are you sure you want to clear the queue?") == True:
				hellanzb.clear()
		else:
			message.message("Not connected", "You must be connected to be able to remove an NZB from the queue!")
			
	def importNzb(self, widget=None, data=None):
		if hellanzb.started_success == True:
			self.nzb_file_chooser = gtk.FileChooserDialog("Select your NZB",
															None,
															gtk.FILE_CHOOSER_ACTION_OPEN,
															(gtk.STOCK_CANCEL, gtk.RESPONSE_CANCEL,
															gtk.STOCK_OPEN, gtk.RESPONSE_OK))
			self.nzb_file_chooser.set_default_response(gtk.RESPONSE_OK)
			self.nzb_file_chooser.set_select_multiple(False)
				
			filter = gtk.FileFilter()
			filter.set_name("NZB-files (.nzb)")
			filter.add_pattern("*.nzb")
			self.nzb_file_chooser.add_filter(filter)
				
			filter = gtk.FileFilter()
			filter.set_name("All files")
			filter.add_pattern("*")
			self.nzb_file_chooser.add_filter(filter)
				
			self.nzb_file_chooser.set_filename(self.settings_dir)
			response = self.nzb_file_chooser.run()
				
			if response == gtk.RESPONSE_OK:
				filename = self.nzb_file_chooser.get_filename()
				print filename
				print len(filename)
				print filename[len(filename)-4:]
				if filename[len(filename)-4:]==".nzb":
					print "Adding to the queue: " + filename
					if hellanzb.updating_queue == True:
						if settings.get_key(key="general/removeNzb", type="bool", default=False) == True:
							os.system("mv '" + os.path.realpath(filename) + "' '" + self.watch_path + "'")
						else:
							os.system("cp '" + os.path.realpath(filename) + "' '" + self.watch_path + "'")
					else:
						if settings.get_key(key="general/removeNzb", type="bool", default=False) == True:
							hellanzb.enqueue(os.path.realpath(filename), True)
						else:
							hellanzb.enqueue(os.path.realpath(filename), False)
			self.nzb_file_chooser.destroy()
			
	def dndNzb(self, widget, context, x, y, selection, targetType, time):
		if hellanzb.started_success == True:
			filename = selection.data.replace("file://","")
			filename = filename.replace("\r\n","")
			filename = filename.replace("%20"," ")
			print filename
			print len(filename)
			print filename[len(filename)-4:]
			if filename[len(filename)-4:] == ".nzb":
				if hellanzb.updating_queue == True:
					if settings.get_key(key="general/removeNzb", type="bool", default=False) == True:
						os.system("mv '" + os.path.realpath(filename) + "' '" + self.watch_path + "'")
					else:
						os.system("cp '" + os.path.realpath(filename) + "' '" + self.watch_path + "'")
				else:
					print "Adding to the queue: " + filename
					if settings.get_key(key="general/removeNzb", type="bool", default=False) == True:
						hellanzb.enqueue(filename, True)
					else:
						hellanzb.enqueue(filename, False)
			
	def dequeueNzb(self, widget=None, data=None):
		key = gtk.gdk.keyval_name(data.keyval)
		if key == "Delete":
			selected_item = self.queue_tree.get_selection()
			tree_model, tree_iter = selected_item.get_selected()
			try:
				print "Dequeueing " + self.queue_lst.get_value(tree_iter, 0) + " from queue"
				if hellanzb.started_success == True:
					question = "Are you sure you want to delete " + self.queue_lst.get_value(tree_iter, 0) + "?"
					if message.question("Removing NZB from the queue", question) == True:
						hellanzb.dequeue(self.queue_lst.get_value(tree_iter, 2))
				else:
					message.message("Not connected", "You must be connected to be able to remove an NZB from the queue!")
			except TypeError:
				error.print_error("No entry selected")
			except:
				error.print_error("Error forcing nzb to download: " + str(sys.exc_info()[1]))
				
	def forceNzb(self, widget=None, data=None):
		message.print_message("test")
		if data.type == gtk.gdk._2BUTTON_PRESS and len(self.queue_lst) > 0 and hellanzb.started_success == True:
			selected_item = self.queue_tree.get_selection()
			tree_model, tree_iter = selected_item.get_selected()
			try:
				if message.question("Forcing download", "Are you sure you want to start downloading " + self.queue_lst.get_value(tree_iter, 0) + "?") == True:
					message.print_message("Forcing " + self.queue_lst.get_value(tree_iter, 0) + " to download")
					hellanzb.force(self.queue_lst.get_value(tree_iter, 2))
			except TypeError:
				message.print_message("No enty selected")
			except:
				error.print_error("Could not force nzb to download: " + str(sys.exc_info()[1]))
				print
			
	#Queue watch directory methods
	def startMonitorFolder(self, path):
		class PClose(ProcessEvent):
			def process_IN_CLOSE_NOWRITE(self, event):
				file = event.name and os.path.join(event.path, event.name)
				ext = file[len(file)-3:len(file)]
				if lower(ext) == "nzb" and os.path.isfile(file):
					if not hellanzb.updating_queue == True:
						print "Adding to the queue: " + file
						hellanzb.enqueue(file, True)
					
		self.queueFilesWatchdir(path)
				
		self.wm = WatchManager()
		self.notifier = Notifier(self.wm, PClose())
		self.mask = EventsCodes.IN_CLOSE_NOWRITE
		self.recursive = settings.get_key(key="general/watchdir_recursive", type="bool")
		self.wdd = self.wm.add_watch(path, self.mask, rec=self.recursive)
		self.monitoring = True
		print "Creating notifier on " + path + ", option recursive is " + str(self.recursive)
			
	def stopMonitorFolder(self):
		self.notifier.stop()
		self.monitoring = False
		
	def checkWatchDirChange(self):
		if (not self.watch_path == os.path.realpath(settings.get_key(key="general/watchdir", type="string", output=False))) or (not self.recursive == settings.get_key(key="general/watchdir_recursive", type="bool", output=False)):
			print "chaning the watch folder and recursive option"
			print "removing folder: " + str(self.watch_path) + " with recursive " + str(self.recursive)
			self.wm.rm_watch(self.wdd.values())
			self.watch_path = os.path.realpath(settings.get_key(key="general/watchdir", type="string"))
			self.queueFilesWatchdir(self.watch_path)
			self.recursive = settings.get_key(key="general/watchdir_recursive", type="bool")
			print "adding folder: " + str(self.watch_path) + " with recursive " + str(self.recursive)
			self.wdd = self.wm.add_watch(self.watch_path, self.mask, rec=self.recursive)
			self.general_settings_watchdir_entry.set_text(self.watch_path)
			
	def queueFilesWatchdir(self, path):
		#Add every file that already exists in the watch folder to the queue
		files = os.listdir(path)
		for x in range(len(files)):
			if lower(files[x][len(files[x])-4:len(files[x])]) == ".nzb":
				hellanzb.enqueue(location=os.path.join(self.watch_path,files[x]), rm=True)
				print "Adding already existing files to the queue: " + files[x]
		
	#General settings methods
	def saveGeneralSettings(self, widget=None, data=None):
		try:
			if os.path.isdir(self.general_settings_watchdir_entry.get_text()):
				settings.set_key(key="general/watchdir", type="string", value=self.general_settings_watchdir_entry.get_text())
				
			settings.set_key(key="general/updatespeed", type="int", value=int(self.general_settings_updatespeed_scale.get_value()))
			self.update_speed = int(self.general_settings_updatespeed_scale.get_value())
			settings.set_key(key="general/watchdir_recursive", type="bool", value=self.general_settings_watchfolder_recursive_checkbox.get_active())
			settings.set_key(key="general/removeNzb", type="bool", value=self.general_settings_removeNzb_checkbox.get_active())
			
			message.message("Saved successfully", "Your settings have now been succesfully saved!")
		except:
			error.normal_error("Something went wrong when saving the settings! Your old settings will now be restored!")
			self.restoreGeneralSettings()
			
	def restoreGeneralSettings(self, widget=None, data=None):
		self.general_settings_watchdir_entry.set_text(settings.get_key(key="general/watchdir", type="string"))
		self.general_settings_updatespeed_scale.set_value(settings.get_key(key="general/updatespeed", type="int"))
		self.general_settings_watchfolder_recursive_checkbox.set_active(settings.get_key(key="general/watchdir_recursive", type="bool"))
		
	#Server settings methods
	def readServerList(self):
		self.servers = settings.get_key(key="hellanzb/servers", type="list", default=[], list_type="string", output=False)
		counter = 0
		for x in range(len(self.servers)/7):
			start = x * 7
			self.servers_list.append([self.servers[start], self.servers[start+1], self.servers[start+2], int(self.servers[start+3]), self.servers[start+4], bool(self.servers[start+5]), bool(self.servers[start+6])])
		self.server_string_old = self.createServerString()
		self.downoad_dir_old = self.createDownloadDirString()
		
	def createServerString(self):
		server_string = ""
		for x in range(len(self.servers_list)):
			if self.servers_list[x][6] == True:
				#When no username is filled in the username and password will be set to 'None'
				if  self.servers_list[x][1] == "":
					self.username_txt = "username = None"
					self.password_txt = "password = None"
				else:
					self.username_txt = "username = '" + self.servers_list[x][1] + "'"
					self.password_txt = "password = '" + self.servers_list[x][2] + "'"
				#Adding the hellanzb.conf-string
				server_string = server_string + "defineServer(id='" + self.servers_list[x][0] + "',\n\thosts = [ '" + self.servers_list[x][0] + ":" +  self.servers_list[x][4] + "' ],\n\t" +  self.username_txt + ",\n\t" + self.password_txt + ",\n\tconnections = " + str(self.servers_list[x][3]) + ",\n\tantiIdle = 4.5 * 60,\n\tssl = " + str(self.servers_list[x][5]) + "\n\t)\n"
		return server_string
		
	def createDownloadDirString(self):
		return "Hellanzb.PREFIX_DIR = '" + settings.get_key(key="hellanzb/downloadfolder", type="string", default="~") + "'"
		
	def enable_ssl(self, widget, data=None):
		if widget.get_active():
			widget.set_text('563')
		else:
			widget.set_text('119')
		
	#Methods for all use!
	def calculateKbToMb(self, value=0):
		#Recalculating MB to GB
		if value>=1024:
			newValue = 0.00 + value
			newValue = round(newValue / 1024, 1)
			returnValue = str(newValue) + " MB"
		else:
			returnValue = str(value) + " KB"
			
		return returnValue
		
	def calculateMbToGb(self, value=0):
		#Recalculating MB to GB
		if value>=1024:
			newValue = 0.00 + value
			newValue = round(newValue / 1024, 2)
			returnValue = str(newValue) + " GB"
		else:
			returnValue = str(value) + " MB"
			
		return returnValue
		
	def calculateEta(self, value=0):
		#Recalculating ETA
		tmpEtaHours = int(value / (60 * 60))
		tmpEtaMinutes = int((value  - (tmpEtaHours * 60 * 60)) / 60)
		tmpEtaSeconds = int(value  - (tmpEtaHours * 60 * 60) - (tmpEtaMinutes * 60))

		strEtaMinutes = ""
		strEtaSeconds = ""

		if tmpEtaMinutes<10:
			strEtaMinutes = "0" + str(tmpEtaMinutes)
		else:
			strEtaMinutes = str(tmpEtaMinutes)

		if tmpEtaSeconds<10:
			strEtaSeconds = "0" + str(tmpEtaSeconds)
		else:
			strEtaSeconds = str(tmpEtaSeconds)

		final = str(tmpEtaHours) + ":" + strEtaMinutes + ":" + strEtaSeconds
		return final
		
	#Hellanzb system operations!
	def connectHellanzb(self, widget=None, data=None):
		if self.running_hellanzb == False:
			self.connectHellanzbStart()
		else:
			self.connectHellanzbStop()
			
	def reconnectHellanzb(self, widget=None, data=None):
		if self.running_hellaznb == True:
			self.connectHellanzbStop()
			self.connectHellanzbStart()
		
	def connectHellanzbStart(self):
		#Starting hellaNZB"
		hellanzb.connect(self.hella, self.hella_config_file)
		if (hellanzb.started == False) or (hellanzb.started_success == False):
			self.connectHellanzbStop()
		else:
			self.running_hellanzb = True
			self.stats_status_hellanzb_image.set_from_stock(gtk.STOCK_MEDIA_PLAY, gtk.ICON_SIZE_SMALL_TOOLBAR)
			#showing the disconnect button instead of the connect button
			self.options_connect.hide()
			self.options_disconnect.show()
			self.tray_icon_connect.hide()
			self.tray_icon_disconnect.show()
			#Enable adding file, clearing queue,... after hellanzb started
			self.add_nzb_permission = True
			self.options_pause.show()
			self.options_open.show()
			self.options_clear_queue.show()
			self.options_nzb_up.show()
			self.options_nzb_down.show()
			self.options_cancel.show()
			
			#Showing tray functions
			self.tray_icon_pause.show()
			self.pause_hellanzb = False
			self.tray_icon_continue.hide()
			self.tray_icon_open_nzb.show()
			self.tray_icon_clear_queue.show()
			
			#Starting the monitoring
			try:
				self.watch_path = os.path.realpath(settings.get_key(key="general/watchdir", type="string"))
			except IndexError:
				print 'use: %s dir' % sys.argv[0]
			else:
				self.startMonitorFolder(self.watch_path)
		
	def connectHellanzbStop(self):
		hellanzb.disconnect(self.hella)
		self.running_hellanzb = False
		self.stats_status_hellanzb_image.set_from_stock(gtk.STOCK_MEDIA_STOP, gtk.ICON_SIZE_SMALL_TOOLBAR)
		#Disable adding file when hellanzb stopped
		self.add_nzb_permission = False
		self.options_pause.hide()
		self.options_pause.set_active(False)
		self.options_open.hide()
		self.options_clear_queue.hide()
		self.options_nzb_up.hide()
		self.options_nzb_down.hide()
		self.options_cancel.hide()
		#showing the connect button
		self.options_disconnect.hide()
		self.options_connect.show()
		#Disable most of the tray functionality
		self.tray_icon_disconnect.hide()
		self.tray_icon_connect.show()
		self.tray_icon_open_nzb.hide()
		self.tray_icon_clear_queue.hide()
		self.statsResetDefault()
		
		#Hiding try functions
		self.tray_icon_continue.hide()
		self.tray_icon_pause.hide()
		
		if self.monitoring == True:
			self.stopMonitorFolder()
			
	def pauseHellanzb(self, widget=None, data=None):
		if hellanzb.started_success == True:
			if self.pause_hellanzb == False:
				try:
					self.stats_status_hellanzb_image.set_from_stock(gtk.STOCK_MEDIA_PAUSE, gtk.ICON_SIZE_SMALL_TOOLBAR)
					self.options_pause.set_active(True)
					hellanzb.pause()
					self.pause_hellanzb = True
					self.tray_icon_continue.show()
					self.tray_icon_pause.hide()
				except:
					error.print_error("Could not pause the download!")
			else:
				try:
					self.stats_status_hellanzb_image.set_from_stock(gtk.STOCK_MEDIA_PLAY, gtk.ICON_SIZE_SMALL_TOOLBAR)
					self.options_pause.set_active(False)
					hellanzb.unpause(self.hella)
					self.pause_hellanzb = False
					self.tray_icon_continue.hide()
					self.tray_icon_pause.show()
				except:
					error.print_error("Could not continue the download!")
					
	def about(self, widget=None, data=None):
		self.window_about.show()
		
	def aboutClose(self, widget=None, data=None):
		self.window_about.hide()
		return True
		
	def aboutResponse(self, dialog, response, *args):
		if response < 0:
			dialog.hide()
			dialog.emit_stop_by_name("response")
		
	def close(self, widget=None, data=None):
		self.window.hide()
		
		#Stopping hellanzb
		print "Closing hellanzb..."
		self.connectHellanzbStop()
		
		#Stopping the thread
		print "Closing the thread..."
		self.running = False
		
		#Stopping the main program
 		print "Exiting program..."
 		gtk.main_quit()
	 	
		return False

if __name__ == "__main__":
 myhella = MyHella()
 myhella.start()
 gtk.main()

#box.pack_start(child, expand=True, fill=True, padding=0)

#The expand argument to pack_start() and pack_end() controls whether the widgets are laid out in the box to fill in all the extra space in the box so the box is expanded to fill the area allotted to it (True); or the box is shrunk to just fit the widgets (False). Setting expand to False will allow you to do right and left justification of your widgets. Otherwise, they will all expand to fit into the box, and the same effect could be achieved by using only one of pack_start() or pack_end().

#The fill argument to the pack methods control whether the extra space is allocated to the objects themselves (True), or as extra padding in the box around these objects (False). It only has an effect if the expand argument is also True.
