import gconf
import os

class Settings():
	def __init__(self, version=None):
		#Vars
		self.settings_base = "/apps/myhella"
		#Connecting to gconf
		self.settings_client = gconf.client_get_default()
		#checking for the version-var and updating if nessacary
		if not version == None:
			if self.get_key(key="version", type="string", default=True) == False or not self.get_key(key="version", type="string", default=True) == version:
				self.set_key(key="version", type="string", value=version)
			
	def get_key(self, key, type, default=None, list_type=None, output=True):
		key = os.path.join(self.settings_base, key)
		v = None
		if default == None:
			default = False
		if self.settings_client.get( key ):
			if type == "bool":
				v = self.settings_client.get_bool( key )
			if type == "int":
				v = self.settings_client.get_int(key)
			if type == "float":
				v = self.settings_client.get_float(key)
			if type == "string":
				v = self.settings_client.get_string(key)
			if type == "list":
				v = self.settings_client.get_list(key, list_type)
				
			if v == None:
				if output == True:
					print "Getting key: " + key + " | Value: " + str(default)
				return default
			else:
				if output == True:
					print "Getting key: " + key + " | Value: " + str(v)
				return v
		else:
			if output == True:
				print "Getting key: " + key + " | Value: " + str(default)
			return default
			
	def set_key(self, key, type, value, list_value=None, output=True):
		if output == True:
			print "Setting key: " + key + " | Value: " + str(value)
		key = os.path.join(self.settings_base, key)
		if type == "bool":
			self.settings_client.set_bool(key, value)
		if type == "int":
			self.settings_client.set_int(key, value)
		if type == "float":
			self.settings_client.set_float(key, value)
		if type == "string":
			self.settings_client.set_string(key, value)
		if type == "list":
			if (list_value == None) or (list_value == "string"):
				self.settings_client.set_list(key, gconf.VALUE_STRING, value)
			if (list_value == "list"):
				self.settings_client.set_list(key, gconf.VALUE_LIST, value)
